function kQ4 = SztywnoscQ4PSN(E,ni,t,x1,y1,x2,y2,x3,y3,x4,y4)
%Wyznacza macierz sztywnosci pojedynczego elementu czworokatnego Q4
%na podstawie parametrow materialowych oraz wspolrzednych wezlow
%w Plaskim Stanie Naprezenia
%wynik 8x8

%1. Macierz sprezystosci - plaski stan naprezenia
D = Dpsn(E, ni);

%WSPOLRZEDNE PUNKTOW GAUSSA
ksi(1) = -sqrt(1.0 ./ 3.0);
eta(1) = sqrt(1.0 ./ 3.0);

ksi(2) = sqrt(1.0 ./ 3.0);
eta(2) = sqrt(1.0 ./ 3.0);

ksi(3) = sqrt(1.0 ./ 3.0);
eta(3) = -sqrt(1.0 ./ 3.0);

ksi(4) = -sqrt(1.0 ./ 3.0);
eta(4) = -sqrt(1.0 ./ 3.0);

%CAKOWANIE = SUMOWANIE PO PUNKTACH GAUSSA
kQ4=zeros(8,8);
for i = 1:4
    
    %2. Macierz Jacobiego
    Jacobi = Q4J(x1, y1, x2, y2, x3, y3, x4, y4, ksi(i), eta(i));

    %3. Jacobian - wyznacznik z macierzy Jakobiego
    detJacobi = det(Jacobi);

    %4. Odwrocona macierz Jacobiego
    invJacobi = inv(Jacobi);

    %5. Pochodne funkcji ksztaltu po zmiennych lokalnych
    dNdL = Q4derivNL(ksi(i), eta(i));

    %6. Pochodne funkcji ksztaltu po zmiennych globalnych
    dNdx = Q4derivNx(invJacobi, dNdL);

    %7. Ukladanie macierzy B
    B = Q4makeB(dNdx);

    %8. Oblicza iloczyn BT*D*B
    BDB = B' * D * B;

    %9. Oblicza macierz sztywnosci (calkowanie w punkcie Gaussa)
    k = 1.0 * detJacobi * BDB;
    
    %10. I sumuje wyniki
    kQ4 = kQ4 + k;
end
%uwzgledniamy grubosc elementu
kQ4 = t .* kQ4;
%KONIEC SUMOWANIA (CAKOWANIA)